

// Khởi tạo biến để lưu trữ URL hiện tại
let lastUrl = window.location.href;
let message = []; // Khai báo biến global

function updatecontent(){
  chrome.storage.local.get('serverResponse', function(result) {
    if (result.serverResponse) {
      console.log('Data from server:', result.serverResponse);
      message = result.serverResponse.message;
      // Kiểm tra nếu message không phải là một mảng
      if (!Array.isArray(message)) {
        message = [message]; // Chuyển đổi thành mảng chứa phần tử đó
      }
    } else {
      console.log('No data found in storage.');
    }
  });

}


// Hàm để tạo hoặc cập nhật popup URL
function updatePopupUrl() {
  // Kiểm tra nếu URL hiện tại khác với URL trước đó
  const currentUrl = window.location.href;
  if (currentUrl !== lastUrl) {
    lastUrl = currentUrl; // Cập nhật lastUrl thành URL hiện tại
    const urlObj = new URL(currentUrl);
    const move = parseInt(urlObj.searchParams.get("move"), 10);
    console.log(move); // 122 (kiểu number)
    const content = message[move]

    // Kiểm tra nếu popup đã tồn tại thì chỉ cần cập nhật nội dung
    let urlPopup = document.getElementById("url-popup");
    let urlText;

    if (urlPopup) {
      urlText = urlPopup.querySelector(".url-text");
      urlText.textContent = content;
    } else {
      // Nếu popup chưa tồn tại, tạo popup mới
      urlPopup = document.createElement("div");
      urlPopup.id = "url-popup";

      // Tạo thẻ hình ảnh
      const img = document.createElement("img");
      img.src = "https://assets-coaches.chess.com/image/coachdavid.png"; // URL của hình ảnh
      img.alt = "Coach";
      img.style.width = "96px"; // Kích thước cố định
      img.style.height = "96px";
      img.style.borderRadius = "50%";
      img.style.marginRight = "10px";
      
      // Tạo thẻ chứa nội dung URL
      urlText = document.createElement("div");
      urlText.className = "url-text";
      urlText.textContent = currentUrl;
      urlText.style.color = "black"; // Đổi màu chữ thành đen
      urlText.style.fontSize = "14px";
      urlText.style.maxWidth = "250px";
      urlText.style.wordWrap = "break-word"; // Đảm bảo chữ không bị lố ra ngoài

      // Thiết lập CSS cho popup
      urlPopup.style.position = "fixed";
      urlPopup.style.top = "20px";  // Vị trí ở góc trên cùng
      urlPopup.style.right = "20px";  // Vị trí ở góc bên phải
      urlPopup.style.backgroundColor = "white"; // Nền trắng
      urlPopup.style.color = "black"; // Chữ đen
      urlPopup.style.fontSize = "14px";
      urlPopup.style.borderRadius = "5px";
      urlPopup.style.padding = "10px";
      urlPopup.style.boxShadow = "0px 0px 10px rgba(0, 0, 0, 0.5)";
      urlPopup.style.zIndex = "10000";
      urlPopup.style.maxWidth = "400px";
      urlPopup.style.display = "flex";
      urlPopup.style.alignItems = "center";
      urlPopup.style.cursor = "move";

      // Thêm hình ảnh và nội dung URL vào popup
      urlPopup.appendChild(img);
      urlPopup.appendChild(urlText);

      // Thêm popup vào trang
      document.body.appendChild(urlPopup);

      // Cài đặt chức năng kéo thả cho popup
      let isDragging = false;
      let offsetX = 0;
      let offsetY = 0;
    
      // Bắt đầu kéo khi nhấn chuột hoặc cảm ứng vào popup
      urlPopup.addEventListener("mousedown", function (event) {
        event.preventDefault();
        isDragging = true;
        offsetX = event.clientX - urlPopup.getBoundingClientRect().left;
        offsetY = event.clientY - urlPopup.getBoundingClientRect().top;
      });
    
      urlPopup.addEventListener("touchstart", function (event) {
        event.preventDefault();
        const touch = event.touches[0];
        isDragging = true;
        offsetX = touch.clientX - urlPopup.getBoundingClientRect().left;
        offsetY = touch.clientY - urlPopup.getBoundingClientRect().top;
      });
    
      // Di chuyển popup theo vị trí con trỏ hoặc cảm ứng khi kéo
      document.addEventListener("mousemove", function (event) {
        if (isDragging) {
          event.preventDefault();
          urlPopup.style.left = event.clientX - offsetX + "px";
          urlPopup.style.top = event.clientY - offsetY + "px";
        }
      });
    
      document.addEventListener("touchmove", function (event) {
        if (isDragging) {
          event.preventDefault();
          const touch = event.touches[0];
          urlPopup.style.left = touch.clientX - offsetX + "px";
          urlPopup.style.top = touch.clientY - offsetY + "px";
        }
      });
    
      // Thả chuột hoặc ngón tay để dừng kéo
      document.addEventListener("mouseup", function () {
        isDragging = false;
      });
    
      document.addEventListener("touchend", function () {
        isDragging = false;
      });
    }      
  }
}

// Gọi hàm để khởi tạo popup ban đầu
updatePopupUrl();

// Theo dõi sự kiện `popstate` (nếu có) để cập nhật URL
window.addEventListener("popstate", updatePopupUrl);

// Ghi đè `pushState` và `replaceState` để cập nhật khi có thay đổi
const originalPushState = history.pushState;
const originalReplaceState = history.replaceState;

history.pushState = function(...args) {
  originalPushState.apply(this, args);
  updatePopupUrl();
};

history.replaceState = function(...args) {
  originalReplaceState.apply(this, args);
  updatePopupUrl();
};

// Kiểm tra URL mỗi giây (1000ms) để phát hiện thay đổi mà không qua sự kiện
setInterval(updatePopupUrl, 100);
setInterval(updatecontent, 100);



